﻿using ProjectExcavator.DrawingObjects;
using ProjectExcavator.Entities;
using System.Diagnostics.CodeAnalysis;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectExcavator.Generics
{
    internal class DrawningExcavatorEqutables : IEqualityComparer<DrawingExcavator?>
    {
        public bool Equals(DrawingExcavator? x, DrawingExcavator? y)
        {
            if (x == null || x.EntityExcavator == null)
            {
                throw new ArgumentNullException(nameof(x));
            }
            if (y == null || y.EntityExcavator == null)
            {
                throw new ArgumentNullException(nameof(y));
            }
            if (x.GetType().Name != y.GetType().Name)
            {
                return false;
            }
            if (x.EntityExcavator.Speed != y.EntityExcavator.Speed)
            {
                return false;
            }
            if (x.EntityExcavator.Weight != y.EntityExcavator.Weight)
            {
                return false;
            }
            if (x.EntityExcavator.BodyColor != y.EntityExcavator.BodyColor)
            {
                return false;
            }
            if (x is DrawingExcavatorKovsh && y is DrawingExcavatorKovsh)
            {
                // TODO доделать логику сравнения дополнительных параметров
                EntityExcavatorKovsh _excavatorX = (EntityExcavatorKovsh)x.EntityExcavator;
                EntityExcavatorKovsh _excavatorY = (EntityExcavatorKovsh)y.EntityExcavator;
                if (_excavatorX.Kovsh != _excavatorY.Kovsh)
                {
                    return false;
                }
                if (_excavatorX.Katki != _excavatorY.Katki)
                {
                    return false;
                }
                if (_excavatorX.AdditionalColor != _excavatorY.AdditionalColor)
                {
                    return false;
                }
            }
            return true;
        }
        public int GetHashCode([DisallowNull] DrawingExcavator obj)
        {
            return obj.GetHashCode();
        }
    }
}
