﻿using ProjectExcavator.DrawingObjects;
using ProjectExcavator.Entities;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectExcavator.Generics
{
    internal class ExcavatorCompareByColor : IComparer<DrawingExcavator?>
    {
        public int Compare(DrawingExcavator? x, DrawingExcavator? y)
        {
            if (x == null || x.EntityExcavator == null)
            {
                throw new ArgumentNullException(nameof(x));
            }
            if (y == null || y.EntityExcavator == null)
            {
                throw new ArgumentNullException(nameof(y));
            }
            if (x.EntityExcavator.BodyColor.Name != y.EntityExcavator.BodyColor.Name)
            {
                return x.EntityExcavator.BodyColor.Name.CompareTo(y.EntityExcavator.BodyColor.Name);
            }
            if (x.GetType().Name != y.GetType().Name)
            {
                return x.GetType().Name.CompareTo(y.GetType().Name);
            }
            if (x.GetType().Name == y.GetType().Name && x is DrawingExcavatorKovsh)
            {
                EntityExcavatorKovsh _exX = (EntityExcavatorKovsh)x.EntityExcavator;
                EntityExcavatorKovsh _exY = (EntityExcavatorKovsh)y.EntityExcavator;

                if (_exX.AdditionalColor.Name != _exY.AdditionalColor.Name)
                {
                    return _exX.AdditionalColor.Name.CompareTo(_exY.AdditionalColor.Name);
                }
            }

            var speedCompare = x.EntityExcavator.Speed.CompareTo(y.EntityExcavator.Speed);
            if (speedCompare != 0)
            {
                return speedCompare;
            }
            return x.EntityExcavator.Weight.CompareTo(y.EntityExcavator.Weight);

        }
    }
}
