﻿using ProjectExcavator.DrawingObjects;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectExcavator.Generics
{
    internal class ExcavatorCompareByType : IComparer<DrawingExcavator?>
    {
        public int Compare(DrawingExcavator? x, DrawingExcavator? y)
        {
            if (x == null || x.EntityExcavator == null)
            {
                throw new ArgumentNullException(nameof(x));
            }
            if (y == null || y.EntityExcavator == null)
            {
                throw new ArgumentNullException(nameof(y));
            }
            if (x.GetType().Name != y.GetType().Name)
            {
                return x.GetType().Name.CompareTo(y.GetType().Name);
            }
            var speedCompare =
            x.EntityExcavator.Speed.CompareTo(y.EntityExcavator.Speed);
            if (speedCompare != 0)
            {
                return speedCompare;
            }
            return x.EntityExcavator.Weight.CompareTo(y.EntityExcavator.Weight);
        }
    }
}
